<?php
/**
 * Plugin cinotif
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

/**
 * Condition pour faire apparaître "Publication dans les actualités du site"
 * dans la configuration des abonnements
 */
function inc_cinotif_specifique_permettre_abo_actu_dist(){
	$return = false;
		
	if (defined('_DIR_PLUGIN_CISQUEL')){
                $return = true;
	}
	
	return $return;
}


/**
 * L'article est-il dans les actualites de la page d'accueil ?
 *
 * @param $id_article
 */
function inc_cinotif_specifique_dans_actu_site_dist($id_article=0){
	$return = false;
		
	if (defined('_DIR_PLUGIN_CISQUEL')){
            if ($id_article){
                    // Page d'accueil : actualites 
                    $in = sql_in('raccourci',array('_portail_actu','_portail_permanent_bas','_portail_permanent_bas'));

                    if (($nb=sql_countsel("spip_ci_raccourcis_articles", "id_article=".$id_article." AND ".$in))>0) {
                        $return = true;
                    }
            }
        }
        
	return $return;
}



/////////////////////////////////////////////////////////////////////////////////
/**
 * Dans le cas où le multirubricage est utilisé,
 * liste des rubriques multirubricage pour cet article
 *
 * @param $id_article
 */
function inc_cinotif_specifique_multirubricage_dist($id_article=0) {

	$id_article = intval($id_article);
	$rubriques = array();

	if ($id_article) {
        	if (defined('_DIR_PLUGIN_CISQUEL')) {
			// mots du multirubricage
			$id_mots = array();
			$result = sql_select("id_mot", "spip_mots", "type='_multirubricage'");
			while ($row = sql_fetch($result))
				$id_mots[] = $row['id_mot'];
	
			if ($id_mots) {
				// mots multirubricage de cet article
				$id_mots_article = array();
				$in_mots = sql_in('id_mot',$id_mots); 
				$result = sql_select("id_mot", "spip_mots_liens", "objet='article' AND id_objet=".$id_article." AND ".$in_mots,"","id_mot");
				
				while ($row = sql_fetch($result))
					$id_mots_article[] = $row['id_mot'];
						
				// rubriques avec un des mots multirubricage de cet article
				if ($id_mots_article){
					$rubriques_multi = array();
					$in_mot = sql_in('id_mot',$id_mots_article); 
					$result = sql_select("id_objet as id_rubrique", "spip_mots_liens", "objet='rubrique' AND ".$in_mot,"","id_mot");
					
					while ($row = sql_fetch($result))
						$rubriques_multi[] = $row['id_rubrique'];
		
					// la rubrique doit avoir l'une des formes multirubricage
					if ($rubriques_multi) {	
						$in_rub = sql_in('id_rubrique',$rubriques_multi); 
						$in_forme = sql_in('ciforme',array('_multirubricage',
										'_multirubricagetrirubrique',
										'_2colonnes',
										'_3colonnes',
										'_avecactualite',
										'_calendrier',
										'_espacededie',
										'_etablissements',
										'_etablissements2',
										'_tableau'));
			
						$result = sql_select("id_rubrique", "spip_rubriques", $in_rub." AND ".$in_forme,"","id_rubrique");
						while ($row = sql_fetch($result))
							$rubriques[] = $row['id_rubrique'];
							
					}
				}
			}
                        
		} else {
                        // tag _multirubricage
                        $row = sql_fetsel("*", "spip_groupes_mots", "", "", "", 1);
			if ($row){
                            if (isset($row["tag"])){

                                // groupes de mots du multirubricage
                                $id_groupes_mots = array();
                                $result = sql_select("id_groupe", "spip_groupes_mots", "tag='_multirubricage'");
                                while ($row = sql_fetch($result)) {
                                        $id_groupes_mots[] = $row['id_groupe'];
                                }

                                if ($id_groupes_mots){
                                    // mots du multirubricage
                                    $id_mots = array();
                                    $in_groupes = sql_in('id_groupe',$id_groupes_mots);
                                    $result = sql_select("id_mot", "spip_mots", $in_groupes);
                                    while ($row = sql_fetch($result)){
                                            $id_mots[] = $row['id_mot'];
                                    }
                                    
                                    if ($id_mots) {
                                        // mots multirubricage de cet article
                                        $id_mots_article = array();
                                        $in_mots = sql_in('id_mot',$id_mots); 
                                        $result = sql_select("id_mot", "spip_mots_liens", "objet='article' AND id_objet=".$id_article." AND ".$in_mots,"","id_mot");

                                        while ($row = sql_fetch($result))
                                                $id_mots_article[] = $row['id_mot'];

                                        // rubriques avec un des mots multirubricage de cet article
                                        if ($id_mots_article){
                                                $rubriques_multi = array();
                                                $in_mot = sql_in('id_mot',$id_mots_article); 
                                                $result = sql_select("id_objet as id_rubrique", "spip_mots_liens", "objet='rubrique' AND ".$in_mot,"","id_mot");

                                                while ($row = sql_fetch($result))
                                                        $rubriques_multi[] = $row['id_rubrique'];
                                                
                                                $rubriques = $rubriques_multi;
                                        }
                                    }
                                }
                            }
			}
                    
                }
	}
	
	return $rubriques;
}




////////////////////////////////////////////////////////////////////////////////
/**
 * Dans le cas où des commentaires sont dans un forum ou sur un autre page, etc.
 * URL spécifique à utiliser dans la notification d'un commentaire
 *
 * @param $id_article
 * @param $id_rubrique
 * @param $id_forum
 */
function inc_cinotif_specifique_url_forum_dist($id_article=0,$id_rubrique=0,$id_forum=0) {
        $cipage = '';
	$id_article = intval($id_article);
	$id_rubrique = intval($id_rubrique);
	$id_forum = intval($id_forum);

	if ($id_article AND $id_rubrique AND $id_forum) {
        
            if (defined('_DIR_PLUGIN_CISQUEL')){

                // trouver le message le plus ascendant
                $id_forum_top = $id_forum;
                $id_forum_top_1 = $id_forum;
                $id_fils = $id_forum;
                while ($parent = sql_getfetsel('id_parent', 'spip_forum', 'id_forum='.$id_fils)) {
                        $id_forum_top_1 = $id_fils;
                        $id_forum_top = $parent;
                        $id_fils = $parent;
                }

                // commentaireautrepage
                if (sql_countsel('spip_articles', "id_article=".intval($id_article)." AND ciforme='_commentaireautrepage'")>0){
                        $cipage = 'commentaire&id_article='.$id_article.'&id_forum='.$id_forum_top;

                // forum	
                } elseif (sql_countsel('spip_rubriques', "id_rubrique=".intval($id_rubrique)." AND ciforme='_forum'")>0){
                        // trouver la pagination
                        $pos_id_forum = 0;
                        if ($id_forum_top) {
                                $result = sql_select('id_forum', 'spip_forum', "id_parent=".intval($id_forum_top)." AND statut='publie'","","date_heure");
                                while ($row = sql_fetch($result)){
                                        $pos_id_forum = $pos_id_forum + 1;
                                        if ($row['id_forum']==$id_forum)
                                                break;
                                }
                        }
                        $debut_forum = 10 * floor($pos_id_forum/10);

                        // probleme de debut_forum avec SPIP 3
                        $cidebut = 'debut_forum';
                        if (isset($GLOBALS['meta']['plugin'])){
                            $ciplugins = unserialize($GLOBALS['meta']['plugin']);
                            if (isset($ciplugins['CISQUEL']) AND isset($ciplugins['CISQUEL']['version'])){
                                if (version_compare($ciplugins['CISQUEL']['version'], '2.6.1', '>=')){
                                    $cidebut = 'cisqueldebut';
                                }
                            }
                        }

                        $cipage = 'sujet&id_article='.$id_article.'&id_forum='.$id_forum_top.'&'.$cidebut.'='.$debut_forum;

                // forumhierarchique	
                } elseif (sql_countsel('spip_rubriques', "id_rubrique=".intval($id_rubrique)." AND ciforme='_forumhierarchique'")>0){
                        // trouver la pagination
                        $pos_top_1 = 0;
                        if ($id_forum_top_1) {
                                $result = sql_select('id_forum', 'spip_forum', "id_parent=".intval($id_forum_top)." AND statut='publie'","","date_heure");
                                while ($row = sql_fetch($result)){
                                        $pos_top_1 = $pos_top_1 + 1;
                                        if ($row['id_forum']==$id_forum_top_1)
                                                break;
                                }
                        }
                        $debut_forum = 5 * floor($pos_top_1/5);

                        // probleme de debut_forum avec SPIP 3
                        $cidebut = 'debut_forum';
                        if (isset($GLOBALS['meta']['plugin'])){
                            $ciplugins = unserialize($GLOBALS['meta']['plugin']);
                            if (isset($ciplugins['CISQUEL']) AND isset($ciplugins['CISQUEL']['version'])){
                                if (version_compare($ciplugins['CISQUEL']['version'], '2.6.0', '>=')){
                                    $cidebut = 'cisqueldebut';
                                }
                            }
                        }

                        $cipage = 'sujethierarchique&id_article='.$id_article.'&id_forum='.$id_forum_top.'&'.$cidebut.'='.$debut_forum;
                }
            }
        }
        
        return $cipage;
}








/////////////////////////////////////////////////////////////////////////////////
/**
 * La suite concerne uniquement le cas où des rubriques affichent des actualités
 */


/**
 * Condition pour faire apparaître "Publication dans les actualités du site"
 * dans la configuration des abonnements
 */
function inc_cinotif_specifique_permettre_abo_actu_rubrique_dist(){
	$return = false;
		
	if (defined('_DIR_PLUGIN_CISQUEL')){
                $return = true;
	}
	
	return $return;
}


/**
 * Cette rubrique doit-elle afficher des actualités (ou être une sous page d'accueil) ?
 */
function inc_cinotif_specifique_existence_rubrique_actu_dist($id_objet=0){
	$return = false;
		
	if (defined('_DIR_PLUGIN_CISQUEL')){
            if (sql_countsel("spip_rubriques", "id_rubrique=".$id_objet." AND ".sql_in('ciforme',array('_souspageaccueil','_avecactualite','_3colonnes')))>0){
                    $return = true;
            }
        }
        
	return $return;
}


/**
 * L'article est-il dans les actualites d'une rubrique ?
 *
 * @param $id_article
 */
function inc_cinotif_specifique_dans_actu_rubrique_dist($id_article=0){
	$return = false;
		
	if (defined('_DIR_PLUGIN_CISQUEL')){
            if ($id_article){
                    // Rubrique : actualites 
                    if (($nb=sql_countsel("spip_ci_raccourcis_articles", "id_article=".$id_article." AND raccourci='_rubrique_actu'"))>0) {
                        $return = true;
                    }
            }
        }
        
	return $return;
}


/**
 * Tableau des rubriques ascendantes qui sont avec actualités
 *
 * @param tableau des rubriques ascendantes de l'article
 */
function inc_cinotif_specifique_ascendance_avec_actu_dist($ascendance=array()){
	$ascendance_avec_actu = array();
		
	if (defined('_DIR_PLUGIN_CISQUEL')){
            if ($ascendance){
                    $result = sql_select('id_rubrique', 'spip_rubriques', sql_in('id_rubrique',$ascendance)." AND ".sql_in('ciforme',array('_avecactualite','_3colonnes')));
                    while ($row = sql_fetch($result)){	
                            $ascendance_avec_actu[] = $row['id_rubrique'];
                    }
            }
        }
        
	return $ascendance_avec_actu;
}


/**
 * L'article est-il dans les actualites d'une sous page d'accueil ?
 *
 * @param $id_article
 */
function inc_cinotif_specifique_dans_actu_spaccueil_dist($id_article=0){
	$return = false;
		
	if (defined('_DIR_PLUGIN_CISQUEL')){
            if ($id_article){
                    // Sous page d'accueil : actualites 
                    $in = sql_in('raccourci',array('_souspageaccueil_actu','_souspageaccueil_permanent_bas','_souspageaccueil_permanent_haut'));
                    
                    if (($nb=sql_countsel("spip_ci_raccourcis_articles", "id_article=".$id_article." AND ".$in))>0) {
                        $return = true;
                    }
            }
        }
        
	return $return;
}


/**
 * Tableau des rubriques ascendantes qui sont des sous pages d'accueil
 *
 * @param tableau des rubriques ascendantes de l'article
 */
function inc_cinotif_specifique_ascendance_spaccueil_dist($ascendance=array()){
	$ascendance_spaccueil = array();
		
	if (defined('_DIR_PLUGIN_CISQUEL')){
            if ($ascendance){
                    $result = sql_select('id_rubrique', 'spip_rubriques', sql_in('id_rubrique',$ascendance)." AND ciforme='_souspageaccueil'");
                    while ($row = sql_fetch($result)){	
                            $ascendance_spaccueil[] = $row['id_rubrique'];
                    }
            }
        }
        
	return $ascendance_spaccueil;
}


?>